package org.xdoclet.plugin.weblogic.qtags;

public class WeblogicCacheTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.weblogic.qtags.WeblogicCacheTag {
    public static final String NAME = "weblogic.cache";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"max-beans-in-cache",
		"max-queries-in-cache",
		"idle-timeout-seconds",
		"read-timeout-seconds",
		"concurrency-strategy",
		"cache-between-transactions",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public WeblogicCacheTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public WeblogicCacheTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.Integer getMaxBeansInCache() {
		boolean required = false;
        String result = getNamedParameter("max-beans-in-cache");
        if(required && result == null) {
            bomb("max-beans-in-cache=\"???\" must be specified.");
        }

		java.lang.Integer retVal = null;


		if (result != null) {
	            try {
	                retVal = Integer.decode(result);
	            } catch(NumberFormatException nfe) {
	                bomb("max-beans-in-cache=\"" + result + "\" is not valid integer");
	                throw nfe;
	            }
		}
		
		return retVal;
    }
    public java.lang.Integer getMaxQueriesInCache() {
		boolean required = false;
        String result = getNamedParameter("max-queries-in-cache");
        if(required && result == null) {
            bomb("max-queries-in-cache=\"???\" must be specified.");
        }

		java.lang.Integer retVal = null;


		if (result != null) {
	            try {
	                retVal = Integer.decode(result);
	            } catch(NumberFormatException nfe) {
	                bomb("max-queries-in-cache=\"" + result + "\" is not valid integer");
	                throw nfe;
	            }
		}
		
		return retVal;
    }
    public java.lang.Integer getIdleTimeoutSeconds() {
		boolean required = false;
        String result = getNamedParameter("idle-timeout-seconds");
        if(required && result == null) {
            bomb("idle-timeout-seconds=\"???\" must be specified.");
        }

		java.lang.Integer retVal = null;


		if (result != null) {
	            try {
	                retVal = Integer.decode(result);
	            } catch(NumberFormatException nfe) {
	                bomb("idle-timeout-seconds=\"" + result + "\" is not valid integer");
	                throw nfe;
	            }
		}
		
		return retVal;
    }
    public java.lang.Integer getReadTimeoutSeconds() {
		boolean required = false;
        String result = getNamedParameter("read-timeout-seconds");
        if(required && result == null) {
            bomb("read-timeout-seconds=\"???\" must be specified.");
        }

		java.lang.Integer retVal = null;


		if (result != null) {
	            try {
	                retVal = Integer.decode(result);
	            } catch(NumberFormatException nfe) {
	                bomb("read-timeout-seconds=\"" + result + "\" is not valid integer");
	                throw nfe;
	            }
		}
		
		return retVal;
    }
    public java.lang.String getConcurrencyStrategy() {
		boolean required = false;
        String result = getNamedParameter("concurrency-strategy");
        if(required && result == null) {
            bomb("concurrency-strategy=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getCacheBetweenTransactions() {
		boolean required = false;
        String result = getNamedParameter("cache-between-transactions");
        if(required && result == null) {
            bomb("cache-between-transactions=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getMaxBeansInCache();
        getMaxQueriesInCache();
        getIdleTimeoutSeconds();
        getReadTimeoutSeconds();
        getConcurrencyStrategy();
        getCacheBetweenTransactions();
    }

    public void validateModel() {
        // check uniqueness
    }
}