package org.xdoclet.plugin.weblogic.qtags;

public class WeblogicClusteringTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.weblogic.qtags.WeblogicClusteringTag {
    public static final String NAME = "weblogic.clustering";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"home-is-clusterable",
		"home-load-algorithm",
		"home-call-router-class-name",
		"use-serverside-stubs",
		"stateless-bean-is-clusterable",
		"stateless-bean-load-algorithm",
		"stateless-bean-call-router-class-name",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public WeblogicClusteringTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public WeblogicClusteringTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.Boolean getHomeIsClusterable() {
		boolean required = false;
        String result = getNamedParameter("home-is-clusterable");
        if(required && result == null) {
            bomb("home-is-clusterable=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getHomeLoadAlgorithm() {
		boolean required = false;
        String result = getNamedParameter("home-load-algorithm");
        if(required && result == null) {
            bomb("home-load-algorithm=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getHomeCallRouterClassName() {
		boolean required = false;
        String result = getNamedParameter("home-call-router-class-name");
        if(required && result == null) {
            bomb("home-call-router-class-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getUseServersideStubs() {
		boolean required = false;
        String result = getNamedParameter("use-serverside-stubs");
        if(required && result == null) {
            bomb("use-serverside-stubs=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.Boolean getStatelessBeanIsClusterable() {
		boolean required = false;
        String result = getNamedParameter("stateless-bean-is-clusterable");
        if(required && result == null) {
            bomb("stateless-bean-is-clusterable=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getStatelessBeanLoadAlgorithm() {
		boolean required = false;
        String result = getNamedParameter("stateless-bean-load-algorithm");
        if(required && result == null) {
            bomb("stateless-bean-load-algorithm=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getStatelessBeanCallRouterClassName() {
		boolean required = false;
        String result = getNamedParameter("stateless-bean-call-router-class-name");
        if(required && result == null) {
            bomb("stateless-bean-call-router-class-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness
        // deprecated here. check validateModel
		if(getContext().getTagsByName(NAME).length > 1) {
			bomb("is allowed only once");
		}

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getHomeIsClusterable();
        getHomeLoadAlgorithm();
        getHomeCallRouterClassName();
        getUseServersideStubs();
        getStatelessBeanIsClusterable();
        getStatelessBeanLoadAlgorithm();
        getStatelessBeanCallRouterClassName();
    }

    public void validateModel() {
        // check uniqueness
        if(getContext().getTagsByName(NAME).length > 1) {
            bomb("is allowed only once");
        }
    }
}