package org.xdoclet.plugin.weblogic.qtags;

public class WeblogicRelationTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.weblogic.qtags.WeblogicRelationTag {
    public static final String NAME = "weblogic.relation";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"join-table-name",
		"group-name",
		"db-cascade-delete",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public WeblogicRelationTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public WeblogicRelationTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getJoinTableName() {
		boolean required = false;
        String result = getNamedParameter("join-table-name");
        if(required && result == null) {
            bomb("join-table-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getGroupName() {
		boolean required = false;
        String result = getNamedParameter("group-name");
        if(required && result == null) {
            bomb("group-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getDbCascadeDelete() {
		boolean required = false;
        String result = getNamedParameter("db-cascade-delete");
        if(required && result == null) {
            bomb("db-cascade-delete=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
	            if( !(false || result.equals("true")) ) {
	                // todo we should say what file and line number too
	                bomb("db-cascade-delete=\"" + result + "\" is an invalid parameter value.");
	            }
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }

    protected void validateLocation() {
		if(isOnClass) {
        	bomb("is not allowed on classes");
		}
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getJoinTableName();
        getGroupName();
        getDbCascadeDelete();
    }

    public void validateModel() {
        // check uniqueness
    }
}